/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fernandez_sanchez_abraham_PROG11_Tarea;

import DAO.BbClass;
import java.beans.PropertyVetoException;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

/**
 *
 * @author Abraham Fernandez Sanchez
 */
public final class VistaPasosCreacionTablasBBDD extends javax.swing.JInternalFrame {

    BbClass bBDD;

    /**
     * Creates new form VistaPasosCreacionBBDD
     */
    public VistaPasosCreacionTablasBBDD() {
        initComponents();
        showOffBotoenes();
        mostrarBotones();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButtonCreTablClientes = new javax.swing.JButton();
        jButtonCreTablEscrituras = new javax.swing.JButton();
        jButtonCreTablEscCli = new javax.swing.JButton();

        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Creacion de Tablas");

        jButtonCreTablClientes.setText("CREAR TABLA Clientes");
        jButtonCreTablClientes.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCreTablClientesActionPerformed(evt);
            }
        });

        jButtonCreTablEscrituras.setText("CREAR TABLA Escrituras");
        jButtonCreTablEscrituras.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCreTablEscriturasActionPerformed(evt);
            }
        });

        jButtonCreTablEscCli.setText("CREAR TABLA EscCli");
        jButtonCreTablEscCli.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCreTablEscCliActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(26, 26, 26)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButtonCreTablEscCli, javax.swing.GroupLayout.PREFERRED_SIZE, 172, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButtonCreTablEscrituras)
                    .addComponent(jButtonCreTablClientes, javax.swing.GroupLayout.PREFERRED_SIZE, 172, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(32, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButtonCreTablClientes, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonCreTablEscrituras, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonCreTablEscCli, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 33, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonCreTablClientesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCreTablClientesActionPerformed
        try {
            crearTablaCliente();
        } catch (SQLException ex) {
            Logger.getLogger(VistaPasosCreacionTablasBBDD.class.getName()).log(Level.SEVERE, null, ex);
        }
        mostrarBotones();
    }//GEN-LAST:event_jButtonCreTablClientesActionPerformed

    private void jButtonCreTablEscriturasActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCreTablEscriturasActionPerformed
        crearTablaEscrituras();
        mostrarBotones();
    }//GEN-LAST:event_jButtonCreTablEscriturasActionPerformed

    private void jButtonCreTablEscCliActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCreTablEscCliActionPerformed
        crearTablaEscCli();        
        try {
            confirmacionCreacionBBDDTablas();
            this.setClosed(true);
        } catch (PropertyVetoException | SQLException ex) {
            Logger.getLogger(VistaPasosCreacionTablasBBDD.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jButtonCreTablEscCliActionPerformed

    /**
     * Metodo para la confirmacion de la creacion de la BBDD y sus tablas asociadas
     * @throws SQLException 
     */
    private void confirmacionCreacionBBDDTablas() throws SQLException {
        bBDD = new BbClass();
        boolean tablaClientes = bBDD.tablasExists("Clientes");
        boolean tablaEscrituras = bBDD.tablasExists("Escrituras");
        boolean tablaEscCli = bBDD.tablasExists("EscCli");
        if (bBDD.dbExists() || tablaClientes || tablaEscrituras || tablaEscCli) {
            JOptionPane.showMessageDialog(this, "La BBDD 'notaria' y todas sus tablas han sido creadas satisfactoriamente en el servidor para MySql. \n Puede iniciar el uso de la aplicacion inmediatamente.");
        }
    }

    /**
     * Estado de los botones al inicio del programa
     */
    public void showOffBotoenes() {
        jButtonCreTablClientes.setVisible(false);
        jButtonCreTablEscrituras.setVisible(false);
        jButtonCreTablEscCli.setVisible(false);
    }

    /**
     * mostrara los botones
     */
    public void mostrarBotones() {
        try {
            bBDD = new BbClass();
            if (!bBDD.tablasExists("Clientes")) {
                jButtonCreTablClientes.setVisible(true);
            } else {
                jButtonCreTablClientes.setVisible(false);
            }

            if (!bBDD.tablasExists("Escrituras")) {
                jButtonCreTablEscrituras.setVisible(true);
            } else {
                jButtonCreTablEscrituras.setVisible(false);
            }

            if (bBDD.tablasExists("Clientes") && bBDD.tablasExists("Escrituras")) {
                if (!bBDD.tablasExists("EscCli")) {
                    jButtonCreTablEscCli.setVisible(true);
                } else {
                    jButtonCreTablEscCli.setVisible(false);
                }
            }
        } catch (SQLException ex) {
            Logger.getLogger(VistaPasosCreacionTablasBBDD.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /**
     * Metodo para confirmar la creacion de la tabla Clientes
     */
    private void crearTablaCliente() throws SQLException {
        bBDD = new BbClass();
        //0=SI - 1=NO 
        String accionesRealizar = "Creacion de la Tabla 'Clientes' y que contendra los campos : "
                + "\n - Cod_Cliente, \n - Nombre \n - Telefono \n";
        String mensajeFinal = "¿Realmente quieres Continuar?";
        int respuesta = JOptionPane.showConfirmDialog(null, accionesRealizar + mensajeFinal, "Confirmación", JOptionPane.YES_NO_OPTION);
        if (respuesta == 0) {
            bBDD.creacionTabla("Clientes");
        } else {
            try {
                this.setClosed(true);
            } catch (PropertyVetoException ex) {
                Logger.getLogger(VistaPasosCreacionTablasBBDD.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    /**
     * Metodo para confirmar la creacion de la tabla Clientes Escrituras
     */
    private void crearTablaEscrituras() {
        //0=SI - 1=NO 
        String accionesRealizar = "Creacion de la Tabla 'Escrituras' y que contendra los campos : "
                + "\n - Codigo, \n - Tipo \n - Nom_fich \n - Num_Interv \n";
        String mensajeFinal = "¿Realmente quieres Continuar?";
        int respuesta = JOptionPane.showConfirmDialog(null, accionesRealizar + mensajeFinal, "Confirmación", JOptionPane.YES_NO_OPTION);
        if (respuesta == 0) {
            bBDD.creacionTabla("Escrituras");
        } else {
            try {
                this.setClosed(true);
            } catch (PropertyVetoException ex) {
                Logger.getLogger(VistaPasosCreacionTablasBBDD.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

    }

    /**
     * Metodo para confirmar la creacion de la tabla Clientes EscCli
     */
    private void crearTablaEscCli() {
        //0=SI - 1=NO 
        String accionesRealizar = "Creacion de la Tabla 'EscCli' y que contendra los campos : "
                + "\n - codCli, \n - codEsc ";
        String mensajeFinal = "¿Realmente quieres Continuar?";
        int respuesta = JOptionPane.showConfirmDialog(null, accionesRealizar + mensajeFinal, "Confirmación", JOptionPane.YES_NO_OPTION);
        if (respuesta == 0) {
            bBDD.creacionTabla("EscCli");
        } else {
            try {
                this.setClosed(true);
            } catch (PropertyVetoException ex) {
                Logger.getLogger(VistaPasosCreacionTablasBBDD.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonCreTablClientes;
    private javax.swing.JButton jButtonCreTablEscCli;
    private javax.swing.JButton jButtonCreTablEscrituras;
    // End of variables declaration//GEN-END:variables

}
